package com.hexin.android.component.caitong.firstpage.guide

import android.content.Context
import android.util.AttributeSet
import android.view.LayoutInflater
import android.view.View
import android.widget.RelativeLayout
import com.hexin.plat.android.R

/**
 * author:gaoshiqi
 * date:2020-01-02
 * desc:首页引导view
 */
class FirstPageGuideView(context: Context?, attrs: AttributeSet?) : RelativeLayout(context, attrs) {

    private var curShowIndex = 0
    var onFirstPageGuideEndClickListener : OnFirstPageGuideEndClickListener? = null

    constructor(context: Context?) : this(context, null)

    override fun onFinishInflate() {
        super.onFinishInflate()
        changeGuideView(0)
    }

    private fun changeGuideView(index: Int) {
        if (index < 0 || index >= 3) return
        removeAllViews()
        curShowIndex = index
        var contentView: View? = null
        when (index) {
            0 -> {
                contentView = LayoutInflater.from(context).inflate(R.layout.view_firstpage_guide_one , this, false)
                contentView.setOnClickListener {
                    changeGuideView(1)
                }
            }
            1 -> {
                contentView = LayoutInflater.from(context).inflate(R.layout.view_firstpage_guide_two , this, false)
                contentView.setOnClickListener {
                    changeGuideView(2)
                }
            }
            2 -> {
                contentView = LayoutInflater.from(context).inflate(R.layout.view_firstpage_guide_three , this, false)

                contentView.setOnClickListener {
                    onFirstPageGuideEndClickListener?.let {
                        it.onFirstPageGuideEndClick(this@FirstPageGuideView)
                    }
                }
            }
        }
        addView(contentView)
    }

    interface OnFirstPageGuideEndClickListener {
        fun onFirstPageGuideEndClick(view: View)
    }

}