package com.hexin.android.component.caitong.firstpage.moremenu.transaction

import android.annotation.SuppressLint
import android.content.Context
import android.util.AttributeSet
import android.util.DisplayMetrics
import android.view.MenuItem
import android.view.View
import android.widget.Button
import android.widget.LinearLayout
import androidx.core.widget.NestedScrollView
import androidx.recyclerview.widget.GridLayoutManager
import androidx.recyclerview.widget.LinearSmoothScroller
import androidx.recyclerview.widget.RecyclerView
import com.facebook.drawee.backends.pipeline.Fresco
import com.hexin.android.WeituoNewUtil
import com.hexin.android.component.caitong.firstpage.moremenu.adapter.AppsRecyclerAdapter
import com.hexin.android.component.caitong.firstpage.moremenu.adapter.EntryAppsMoreDataBean
import com.hexin.android.component.caitong.firstpage.moremenu.adapter.EntryUtils
import com.hexin.android.component.firstpage.feedflow.views.tablayout.ExpandedTabLayout
import com.hexin.android.component.htmljump.HtmlJumpFactory
import com.hexin.android.component.htmljump.HtmlJumpSDKInterceptor
import com.hexin.android.service.UserBehaviorFactory
import com.hexin.android.theme.ThemeManager
import com.hexin.android.ui.ComponentContainer
import com.hexin.android.ui.NetWorkClinet
import com.hexin.android.ui.TitleBarStruct
import com.hexin.android.view.HXToast
import com.hexin.android.view.ListMenu
import com.hexin.android.view.base.filter.IMenuFilter
import com.hexin.android.view.base.filter.MenuFilterFactory
import com.hexin.android.weituo.TransLoginInfo
import com.hexin.android.weituo.WeituoMenuUtils
import com.hexin.android.weituo.component.DialogFactory
import com.hexin.android.weituo.component.WeituoBubbleUtils
import com.hexin.android.weituo.rzrq.TransAutoLoginRzrqManager
import com.hexin.android.weituo.yyb.WeituoAccountManager
import com.hexin.android.weituo.yyb.WeituoLoginManager
import com.hexin.android.weituo.yyb.WeituoSwitchAccountManager
import com.hexin.android.weituo.zzxq.utils.ObserverAdapter
import com.hexin.app.AppEntryHolder
import com.hexin.app.event.EQEvent
import com.hexin.app.event.action.EQGotoFrameAction
import com.hexin.middleware.MiddlewareProxy
import com.hexin.middleware.ProtocalDef
import com.hexin.middleware.QueueManagement
import com.hexin.middleware.data.StuffBaseStruct
import com.hexin.middleware.data.mobile.StuffTextStruct
import com.hexin.plat.android.R
import com.hexin.util.HexinUtils
import com.hexin.util.WeituoUftUtils
import com.hexin.util.config.EQConstants
import com.hexin.util.config.SPConfig
import io.reactivex.Observable
import io.reactivex.ObservableOnSubscribe
import io.reactivex.Observer
import io.reactivex.android.schedulers.AndroidSchedulers
import io.reactivex.disposables.Disposable
import io.reactivex.schedulers.Schedulers
import java.util.*
import kotlin.collections.ArrayList
import kotlin.math.ceil

/**
 * Created by Poterking on 19-11-5.
 */
class TransactionMorePage : NestedScrollView, ComponentContainer, AppsRecyclerAdapter.OnItemClickListener {

    private val SPEED_UP = 3

    private var firstLoad = true

    lateinit var mGroupTab: TransactionGroupTab
    lateinit var mAppContain: LinearLayout
    lateinit var mAppsRv: RecyclerView
    lateinit var mTopAppsRv: RecyclerView
    lateinit var deviderView: View


    lateinit var mAppsAdapter: AppsRecyclerAdapter
    lateinit var mTopAppsAdapter: AppsRecyclerAdapter
    lateinit var gridLayoutManager: GridLayoutManager

    private var mTopScroll = 0.0F
    private val mTabHeight = resources.getDimension(R.dimen.dp_40)
    private val mItemHeight = resources.getDimension(R.dimen.dp_65)                        // 菜单item 高度

    private val mItemRecentHeight = resources.getDimension(R.dimen.dp_60)             // 最近使用 栏目中item 高度


    private var mGroupPositions: List<Int> = ArrayList()

    private val updateAppRv = AppRvHeight()
    private val mSelectRunnable = SelectRunnable()
    private val mScrolledRunnable = ScrolledRunnable()

    private var mSelectScrolling = true

    private val menuFilterList : MutableList<IMenuFilter> = mutableListOf()

    constructor(ctx: Context) : super(ctx)

    constructor(ctx: Context, attrs: AttributeSet) : super(ctx, attrs)

    constructor(ctx: Context, attrs: AttributeSet, defStyleAttr: Int) : super(ctx, attrs, defStyleAttr)

    override fun onFinishInflate() {
        super.onFinishInflate()
        mAppsRv = findViewById<View>(R.id.all_apps) as RecyclerView
        mTopAppsRv = findViewById<View>(R.id.top_apps) as RecyclerView
        mGroupTab = findViewById<View>(R.id.top_tab) as TransactionGroupTab
        mAppContain = findViewById<View>(R.id.all_app_contain) as LinearLayout
        deviderView= findViewById<View>(R.id.divider)

        menuFilterList.add(MenuFilterFactory.getMenuFilter(MenuFilterFactory.TYPE_UFT))

        initAppRv()
        initTopAppRv()
        initGroupTab()
        initTheme()
        TransactionEntryDataManager.getInstance().recentAppData
                .subscribeOn(Schedulers.io())
                .observeOn(AndroidSchedulers.mainThread())
                .subscribe(object: ObserverAdapter<List<EntryUtils.RvNode>>() {
                    override fun onNext(t: List<EntryUtils.RvNode>) {
                        if (t != null) {
                            mTopAppsRv.visibility = View.VISIBLE
                            mTopAppsAdapter.dataList = filterNode(t)
                        } else {
                            mTopAppsRv.visibility = View.GONE
                        }
                    }

                })

        TransactionEntryDataManager.getInstance().allAppData
                .subscribe(object: Observer<EntryAppsMoreDataBean> {
                    override fun onComplete() {

                    }

                    override fun onSubscribe(d: Disposable) {

                    }

                    override fun onNext(t: EntryAppsMoreDataBean) {
                        t.apply {
                            mGroupTab.setAppNodes(tabNodes)
                            mAppsAdapter.dataList = filterNode(appNodes)
                            mGroupPositions = groupPositions
                        }
                    }

                    override fun onError(e: Throwable) {

                    }

                })
    }

    private fun filterNode(appNodes: List<EntryUtils.RvNode>) : List<EntryUtils.RvNode> {
        val appNodeListTemp = mutableListOf<EntryUtils.RvNode>()
        appNodeListTemp.addAll(appNodes)
        val iterator = appNodeListTemp.iterator()
        while (iterator.hasNext()) {
            val appNode = iterator.next()
            val menuModel = appNode.data
            if (menuModel is ListMenu.MenuItemModel) {
                for (menuFilter in menuFilterList) {
                    if (menuFilter.filter(menuModel.menuId)) {
                        iterator.remove()
                        break
                    }
                }
            }

        }
        return appNodeListTemp
    }

    private fun initTheme() {
        mGroupTab.setBackgroundColor(ThemeManager.getColor(context, R.color.first_page_foreground_color))
        mGroupTab.setTabTextColors(ThemeManager.getColor(context, R.color.text_dark_color),
                ThemeManager.getColor(context, R.color.red_E93030))
        mGroupTab.setSelectedTabIndicatorColor(ThemeManager.getColor(context, R.color.red_E93030))
        setBackgroundColor(ThemeManager.getColor(context, R.color.first_page_foreground_color))
        mAppContain.setBackgroundColor(ThemeManager.getColor(context, R.color.first_page_foreground_color))
        deviderView.setBackgroundColor(ThemeManager.getColor(context,R.color.gray_EEEEEE))
    }

    @SuppressLint("ClickableViewAccessibility")
    private fun initAppRv() {
        mAppsAdapter = TransactionAPPsRecyclerAdapter(context)
        gridLayoutManager = GridLayoutManager(context,AppsRecyclerAdapter.SPAN_COUNT_DEFAULT)
        gridLayoutManager.spanSizeLookup = object : GridLayoutManager.SpanSizeLookup() {
            override fun getSpanSize(position: Int): Int {
                return mAppsAdapter.getSpanSize(position)
            }
        }
        mAppsRv.layoutManager = gridLayoutManager
        mAppsRv.adapter = mAppsAdapter
        mAppsRv.addItemDecoration(TransactionItemDecoration())
        mAppsRv.setOnTouchListener { _, _ ->
            mSelectScrolling = true
            false
        }
        mAppsRv.addOnScrollListener(object : RecyclerView.OnScrollListener() {
            override fun onScrolled(recyclerView: RecyclerView, dx: Int, dy: Int) {
                super.onScrolled(recyclerView, dx, dy)
                removeCallbacks(mScrolledRunnable)
                post(mScrolledRunnable)
            }

            override fun onScrollStateChanged(recyclerView: RecyclerView, newState: Int) {
                super.onScrollStateChanged(recyclerView, newState)
                if (newState == RecyclerView.SCROLL_STATE_IDLE)
                    Fresco.getImagePipeline().resume()
                else
                    Fresco.getImagePipeline().pause()
            }
        })
        mAppsAdapter.setOnItemClickListener(this)
    }


    private fun initTopAppRv() {
        mTopAppsAdapter = TransactionAPPsRecyclerAdapter(context)
        val manager = GridLayoutManager(context, AppsRecyclerAdapter.SPAN_COUNT_DEFAULT)
        manager.spanSizeLookup = object : GridLayoutManager.SpanSizeLookup() {
            override fun getSpanSize(i: Int): Int {
                return mTopAppsAdapter.getSpanSize(i)
            }
        }
        mTopAppsRv.layoutManager = manager
        mTopAppsRv.adapter = mTopAppsAdapter
        mTopAppsAdapter.setOnItemClickListener(this)
    }

    private fun initGroupTab() {
        mGroupTab.addOnTabSelectedListener(object : ExpandedTabLayout.OnTabSelectedListener {
            override fun onTabSelected(tab: ExpandedTabLayout.Tab) {
                mSelectScrolling = false
                scrollToTab()
                removeCallbacks(mSelectRunnable)
                // 第一个栏目 group index为 -1 需要替换成0
                mSelectRunnable.pos = (if (mGroupPositions[tab.position] == -1) 0 else mGroupPositions[tab.position])
                post(mSelectRunnable)
            }

            override fun onTabUnselected(tab: ExpandedTabLayout.Tab?) {
            }

            override fun onTabReselected(tab: ExpandedTabLayout.Tab?) {
            }
        })
    }


    override fun onMeasure(widthMeasureSpec: Int, heightMeasureSpec: Int) {
        super.onMeasure(widthMeasureSpec, heightMeasureSpec)
        val height = measuredHeight
        //计算最后一项的空白高度  目的为了使得能够刚好滑动到顶部
        val count = TransactionEntryDataManager.getInstance().lastTabItemSize
        val last: Int
        if (count != 0) {
            last = (ceil((count / (AppsRecyclerAdapter.SPAN_COUNT_DEFAULT / AppsRecyclerAdapter.SPAN_COUNT_2).toFloat()).toDouble()) * mItemHeight).toInt() + getGroupHeight() + mTabHeight.toInt()
            mAppsAdapter.lastHeight = height - last + resources.getDimensionPixelOffset(R.dimen.dp_5)
        }

        //计算TopRv的高度
        var topHeight = 0
        if (TransactionEntryDataManager.getInstance().recentAppNodes.size > 2) {
            topHeight += (mItemRecentHeight + getGroupHeight()).toInt()
        }

        topHeight += resources.getDimensionPixelOffset(R.dimen.dp_20) + resources.getDimensionPixelOffset(R.dimen.dp_2)

        val rvHeight = (height - mTabHeight).toInt()
        setRvHeight(topHeight.toFloat(), rvHeight.toFloat())
    }


    private fun getGroupHeight(): Int {
        return resources.getDimensionPixelOffset(R.dimen.dp_10) +
                EntryUtils.measureFontHeight(R.dimen.font_32) +
                resources.getDimensionPixelOffset(R.dimen.dp_6)
    }

    /**
     * 动态设置 上下两个菜单列表高度
     *
     * @param topRvHeight
     * @param rvHeight
     */
    private fun setRvHeight(topRvHeight: Float, rvHeight: Float) {
        mTopScroll = topRvHeight
        removeCallbacks(updateAppRv)
        updateAppRv.setHeight(topRvHeight, rvHeight)
        post(updateAppRv)
    }

    private fun isAtTop(): Boolean {
        return scrollY >= mTopScroll.toInt()
    }

    private fun scrollToTab() {
        if (scrollY.toFloat() != mTopScroll) {
            smoothScrollTo(0, mTopScroll.toInt())
        }
    }

    override fun onNestedPreScroll(target: View, dx: Int, dy: Int, consumed: IntArray,type: Int) {
        val scroll = scrollY
        if (!isAtTop()) {
            //向上
            if (dy > 0) {
                consumed[1] = Math.min(mTopScroll - scroll, dy.toFloat()).toInt()
            } else {
                consumed[1] = dy
            }
            consumed[0] = 0
            scrollBy(0, consumed[1])
        } else {
            consumed[1] = 0
            consumed[0] = 0
        }
    }

    override fun onNestedScroll(target: View, dxConsumed: Int, dyConsumed: Int, dxUnconsumed: Int, dyUnconsumed: Int,type: Int) {
        if (isAtTop()) {
            //向下
            if (dyUnconsumed < 0) {
                scrollBy(0, dyUnconsumed)
            }
        }
    }

    override fun onNestedPreFling(target: View, velocityX: Float, velocityY: Float): Boolean {
        if (!isAtTop()) {
            fling(velocityY.toInt())
            return true
        }
        return super.onNestedPreFling(target, velocityX, velocityY)
    }


    /**
     * item点击
     */
    override fun OnItemClick(adapter: RecyclerView.Adapter<RecyclerView.ViewHolder>, node: EntryUtils.RvNode): Boolean {
        if (node.data !is ListMenu.MenuItemModel)
            return false

        val menuItemModel = node.menuModel

        if (!HexinUtils.checkVersion(menuItemModel.version)) {
            HXToast.makeText(context, context.resources.getString(R.string.app_version_not_support),
                    HXToast.HXTOAST_SHORT, HXToast.TYPE_NORMAL).show()
            return false
        }

        //更新气泡点击状态
        WeituoBubbleUtils.getInstance().bubbleClickEvent(context,
                SPConfig.SP_WEITUO_FIRSTPAGE_MORE_BUBBLE_LIST, menuItemModel.tjId)

        //交易更多页面事件按钮埋点
        val umMap = HashMap<String, String>()
        umMap["tabName"] = menuItemModel.menuText
        UserBehaviorFactory.getInstance(context).saveBehavier("", "", "", null, context, umMap, "trade_more")


        when (menuItemModel.menuId) {
            EQConstants.FRAMEID_WEITUO_RZRQ_OLD, EQConstants.FRAMEID_WEITUO_RZRQ -> return changeAccountToRzrq(node)
            ProtocalDef.FRAMEID_WEITUO_KFSJJ_FIRST -> return onClickKFSJJ(node)                                                        // 开放式基金按钮点击
            WeituoMenuUtils.CT_BONDREVERSE -> HtmlJumpFactory.build(context).url(HtmlJumpSDKInterceptor.buildUrl(HtmlJumpSDKInterceptor.CT_SDK_BONDREVERSE)).jump()   // 财通国债逆回购
            WeituoMenuUtils.CT_CJB -> HtmlJumpFactory.build(getContext()).url(HtmlJumpSDKInterceptor.buildUrl(HtmlJumpSDKInterceptor.CT_SDK_GOLDETF)).jump()            // 财通财金宝
            WeituoMenuUtils.TOCTJUMP ->  HtmlJumpFactory.build(context).url(menuItemModel.jumpUrl)
                    .title( menuItemModel.menuText)
                    .pageId(EQConstants.FRAMEID_CAITONG_LCCP)
                    .jump()
            WeituoMenuUtils.PAGEID_DISALLOW -> {
                WeituoMenuUtils.getInstance().showDialog(this, context.resources.getString(R.string.error), menuItemModel.menuText + "暂不开放")
                return false
            }
            else -> MiddlewareProxy.executorAction(EQGotoFrameAction(EQEvent.EVENT_TYPE_DEFAULT, menuItemModel.menuId))
        }

        return true
    }

    /**
     * 开放式基金按钮点击
     */
    private fun onClickKFSJJ(node: EntryUtils.RvNode): Boolean {
        requestKFSJJ().subscribe(object: ObserverAdapter<StuffBaseStruct>() {
            override fun onNext(struct: StuffBaseStruct) {
                if (struct is StuffTextStruct) {
                    when (struct.id) {
                        3058, 3049 -> {
                            MiddlewareProxy.executorAction(EQGotoFrameAction(EQEvent.EVENT_TYPE_DEFAULT, 3200))
                            TransactionEntryDataManager.getInstance().saveRecentApps(node)
                        } //跳转开放式基金首页
                        3100 -> showKFSJJKHDialog(struct.caption, struct.content)
                        else -> showMsgDialog(struct.caption, struct.content)
                    }
                }
            }
        })
        return false
    }

    /**
     * 请求是否有开放式基金权限
     */
    private fun requestKFSJJ(): Observable<StuffBaseStruct> {
        return Observable.create(ObservableOnSubscribe<StuffBaseStruct> {
            MiddlewareProxy.request(EQConstants.FRAMEID_WEITUO_SALE, 2037, QueueManagement.getId(object : NetWorkClinet {
                override fun receive(struct: StuffBaseStruct) {
                    it.onNext(struct)
                }

                override fun request() {
                }

            }), "")
        }).subscribeOn(Schedulers.io()).observeOn(AndroidSchedulers.mainThread())
    }


    /**
     * 开放式基金相关对话框提示
     */
    private fun showKFSJJKHDialog(title: String, content: String) {
        val dialog = DialogFactory.getTwoBtnDialog(
                context, title, content, resources.getString(R.string.button_cancel),
                resources.getString(R.string.label_ok_key))

        dialog?.findViewById<View>(R.id.ok_btn)?.setOnClickListener {
            val gotoFrameAction = EQGotoFrameAction(EQEvent.EVENT_TYPE_DEFAULT, 3008)
            MiddlewareProxy.executorAction(gotoFrameAction)
            dialog.dismiss()
        }
        dialog?.findViewById<View>(R.id.cancel_btn)?.setOnClickListener {
            dialog.dismiss()
        }
        dialog?.show()
    }

    /**
     * 普通对话框展示
     */
    private fun showMsgDialog(title: String?, content: String?) {
        val dialog = DialogFactory.getOneBtnDialog(context,
                title ?: resources.getString(R.string.revise_notice),
                content ?: "", "确定")
        val okBtn = dialog.findViewById<View>(R.id.ok_btn) as Button
        okBtn.setOnClickListener { dialog.dismiss() }
        dialog.show()
    }


    /**
     * 跳转融资融券
     */
    private fun changeAccountToRzrq(node: EntryUtils.RvNode): Boolean {
        val transAutoLoginRzrqManager = TransAutoLoginRzrqManager(context, ProtocalDef.FRAMEID_WEITUO_HOST)
        WeituoSwitchAccountManager.getInstance().changeAccountToRzrq(transAutoLoginRzrqManager,
                object : WeituoLoginManager.WeituoLoginStatusCallBack {
                    override fun onWeituoLoginSuccess(wtid: String?, qsid: String?, transLoginInfo: TransLoginInfo) {
                        // 刷新当前页面数据
                        post {
                            WeituoUftUtils.saveUftPermission(transLoginInfo.strYyb)

                            val runtimeDataManager = AppEntryHolder.getEQAppFrame().runtimeDataManager
                            if (!runtimeDataManager.isLoginState) {
                                runtimeDataManager.isLoginState = true
                            }
                            if (WeituoAccountManager.getInstance().isCurrentAccountRzrq) {
                                val action = EQGotoFrameAction(EQEvent.EVENT_TYPE_CLICK, WeituoNewUtil.getRzrqFirstPageId())
                                MiddlewareProxy.executorAction(action)
                                TransactionEntryDataManager.getInstance().saveRecentApps(node)
                            }
                        }
                    }

                    override fun onWeituoLoginFaild(wtid: String?, qsid: String?, transLoginInfo: TransLoginInfo?) {
                    }

                    override fun handleReceiveData(struct: StuffBaseStruct?, transLoginInfo: TransLoginInfo?) {
                    }
                }, context)
        return false
    }

    override fun getTitleStruct(): TitleBarStruct? {
        return null
    }

    override fun getBottomVisiable(): Boolean {
        return false
    }

    override fun onMenuItemSelected(item: MenuItem?): Boolean {
        return false
    }

    override fun onComponentContainerForeground() {
        TransactionEntryDataManager.getInstance().refreshRecentAppData().subscribe(object: ObserverAdapter<List<EntryUtils.RvNode>>(){
            override fun onNext(rvTopNodesList: List<EntryUtils.RvNode>) {
                run {
                    if (rvTopNodesList.size > 0 && !firstLoad) {
                        if (mTopAppsRv.visibility == View.GONE)
                            mTopAppsRv.visibility = View.VISIBLE
                        mTopAppsAdapter.dataList = filterNode(rvTopNodesList)
                    }
                    firstLoad = false
                }
            }
        })
    }

    override fun onComponentContainerBackground() {
    }

    override fun onComponentContainerRemove() {
        mGroupTab.clearOnTabSelectedListener()
        mAppsAdapter.removeOnItemClickListener()
        mTopAppsAdapter.removeOnItemClickListener()
    }


    /**
     * 动态重新计算listview
     */
    internal inner class AppRvHeight : Runnable {
        var rvHeight: Float = 0.toFloat()
        var topRvHeight: Float = 0.toFloat()

        fun setHeight(topRvHeight: Float, rvHeight: Float) {
            this.rvHeight = rvHeight
            this.topRvHeight = topRvHeight
        }

        override fun run() {
            val lp = mAppsRv.layoutParams as LinearLayout.LayoutParams
            if (lp.height != rvHeight.toInt()) {
                lp.height = rvHeight.toInt()
                mAppsRv.layoutParams = lp
            }

            val lp1 = mTopAppsRv.layoutParams as LinearLayout.LayoutParams
            if (lp1.height != topRvHeight.toInt()) {
                lp1.height = topRvHeight.toInt()
                mTopAppsRv.layoutParams = lp1
            }
        }
    }

    /**
     * 点击tab list滚动
     */
    internal inner class ScrolledRunnable : Runnable {
        override fun run() {
            val first = gridLayoutManager.findFirstVisibleItemPosition()
            if (mGroupPositions.isNotEmpty() && mSelectScrolling) {
                val size = mGroupPositions.size
                val atLast = mGroupPositions[size - 1]
                val tripPos = mGroupTab.scrollPosition.toInt()
                val selectPos = mGroupTab.selectedTabPosition
                if (first >= atLast) {
                    val index = size - 1
                    if (index != tripPos || index != selectPos) {
                        mGroupTab.setSelect(index, ExpandedTabLayout.TYPE_OTHER)
                    }
                } else {
                    for (i in 0 until mGroupPositions.size - 1) {
                        if (first < mGroupPositions[i + 1] && first >= mGroupPositions[i]) {
                            //choose group i
                            if (i != tripPos || i != selectPos) {
                                mGroupTab.setSelect(i, ExpandedTabLayout.TYPE_OTHER)
                            }
                            break
                        }
                    }
                }

            }
        }
    }

    /**
     * 每次开始新的滚动时，移除之前的消息，且停止rv的滚动，保证状态和scroller处于初始状态
     */
    internal inner class SelectRunnable : Runnable {
        var pos = 0

        override fun run() {
            mAppsRv.stopScroll()
            setSelection(pos)
        }

        fun setSelection(position: Int) {
            val scroller = object : LinearSmoothScroller(context) {
                override fun getVerticalSnapPreference(): Int {
                    return SNAP_TO_START
                }

                override fun calculateSpeedPerPixel(displayMetrics: DisplayMetrics?): Float {
                    return super.calculateSpeedPerPixel(displayMetrics) * SPEED_UP

                }
            }
            scroller.targetPosition = position
            gridLayoutManager.startSmoothScroll(scroller)
        }
    }

}