package com.hexin.android.component.hangqing.hushen

import android.content.Context
import android.util.AttributeSet
import android.widget.LinearLayout
import android.widget.TextView
import com.hexin.android.theme.ThemeManager
import com.hexin.android.ui.Component
import com.hexin.app.event.param.EQParam
import com.hexin.plat.android.R
import java.util.*

/**
 * author:gaoshiqi
 * date:2019-08-27
 * desc:股票排行切换按钮
 */
class StockSortButtonBar(context: Context?, attrs: AttributeSet?) : LinearLayout(context, attrs), Component {

    val tvTabLeft by lazy { findViewById<TextView>(R.id.tv_tab_left) }
    val tvTabRight by lazy { findViewById<TextView>(R.id.tv_tab_right) }
    val tabList = LinkedList<TextView>()

    var curSelectedIndex = -1
    var onTabChangeListener : OnTabChangeListener? = null

    override fun onFinishInflate() {
        super.onFinishInflate()
        tabList.add(tvTabLeft)
        tabList.add(tvTabRight)
        for (i in 0 until tabList.size) {
            tabList.get(i).setOnClickListener{
                changeCheck(i)
            }
        }
        changeCheck(0)
    }

    fun initTheme() {
        changeCheck(curSelectedIndex)
        this.setBackgroundColor(ThemeManager.getColor(context, R.color.global_bg))
    }

    fun changeCheck(checkedIndex : Int) {
        if (checkedIndex < 0 || checkedIndex >= tabList.size) return
        curSelectedIndex = checkedIndex
        var selectTextColor = ThemeManager.getColor(context, R.color.white_FFFFFE)
        var unSelectTextColor = ThemeManager.getColor(context, R.color.new_red)
        for (i in 0 until tabList.size) {
            var tvTab : TextView = tabList.get(i)
            var isTabSelected = (i == checkedIndex)
            if (isTabSelected) {
                tvTab.setTextColor(selectTextColor)
            } else {
                tvTab.setTextColor(unSelectTextColor)

            }
            if (i == 0) {
                if (isTabSelected)
                    tvTab.setBackgroundResource(R.drawable.tab_navi_left_checked)
                else {
                    tvTab.setBackgroundResource(R.drawable.tab_navi_left_not_check)
                }

            } else if (i == tabList.size - 1) {
                if (isTabSelected) {
                    tvTab.setBackgroundResource(R.drawable.tab_navi_right_checked)
                } else {
                    tvTab.setBackgroundResource(R.drawable.tab_navi_right_not_check)
                }
            } else {
                // 这里用于扩展，如果按钮的个数大于两个，则中间按钮的背景色在这里设置
            }
        }
        if (onTabChangeListener != null) {
            onTabChangeListener!!.onTabChanged(curSelectedIndex)
        }
    }

    override fun onPageFinishInflate() {
    }

    override fun OnNotifyProcess(url: String?): Int {
        return 0
    }

    override fun onBackground() {
    }

    override fun onForeground() {
    }

    override fun onRemove() {
    }

    override fun onActivity() {
    }

    override fun lock() {
    }

    override fun unlock() {
    }

    override fun parseRuntimeParam(param: EQParam?) {
    }

}