package com.hexin.android.component.yidong.dpbidyd

import com.hexin.plat.android.HexinApplication
import com.hexin.plat.android.R

/**
 * 该类用来做折线图的配置
 *
 * Create by likai@myhexin.com on 2018-11-28
 */

data class LineChartAxisConfig(
        var valueCount: Int, // 预期折线上一共有多少个点,最小为2
        var horLineCount: Int, // 画线时Y轴会被等分的行数,两跟横线之间为1行,最小为1
        var verLineCount : Int // 画线时X轴会被等分的行数,两跟竖线之间为1行,最小为1
) {

    companion object {
        const val MIN_VALUE_COUNT = 2 // 折线最少需要2个点
        const val MIN_HOR_LINE_COUNT = 1 // 折线图中横向线的数量,不算x轴
        const val MIN_VER_LINE_COUNT = 1 // 折线图中竖向线的数量,不算y轴
    }

    var xText: List<String>? = null // x轴文本,从左到右
    var horLineColor = -1 // 横向数值线的颜色
    var horLineWidth = 1f // 横向数值线的粗细
    var xTextSize = HexinApplication.getHxApplication().resources.getDimension(R.dimen.font_24) // X轴文本字大小
    var xTextColor = -1 // X轴文本字颜色
    var xTextVPadding = 0
    var xTextHPadding = 0
    var yTextSize = HexinApplication.getHxApplication().resources.getDimension(R.dimen.font_24) // Y轴文本字大小
    var yTextColor = -1 // Y轴文本字颜色
    var yPosColor = -1 //涨颜色
    var yNegColor = -1 //跌颜色
    var xPadding = 0 // 该值必须>=0,大于0时,绘制折线的时候会左右往中间缩进,但是水平Y值线不会缩进
    var ySymmetry = true //y轴坐标相对给定的初始值对称（可以是非0值对称）
    var lineCount = 1 //折线的数量，如果有多根，那么ySymmetry属性失效
    var dividLineColor = -1 //边框颜色
    var lineColorForce = false //强制线条颜色 还有一种是红绿色动态设置
    var yAxisLeftPadding  = 0  //y轴标注左右边距
    var yAxisTopPadding  = 0 //y轴标注上下边距
    var waterMark  = true //水印

}