package com.hexin.android.component.yidong.dpbidyd.model

import com.google.gson.annotations.SerializedName
import java.util.*

/**
 * 图表数据
 * Created by yuegang on 19-3-6.
 */
class BidChartDataBean {

    companion object {
        const val INDEX_RISE_NUM = 0 //上涨家数
        const val INDEX_FALL_NUM = 1 //下跌家数
        const val INDEX_RISE_LIMIT_NUM = 2 //涨停数
        const val INDEX_FALL_LIMIT_NUM = 3 //跌停数

        const val ACTION_CLEAR = "clear"
        const val ACTION_ADD   = "add"
        const val ACTION_CHANGE= "change"

        fun sort(data : Array<BidChartDataBean>) {
            Arrays.sort(data, Comparator<BidChartDataBean> { o1, o2 ->
                if (o1 == null || o1.casPosition == null ||
                        o2 == null || o2.casPosition == null) {
                    return@Comparator 0
                }
                if (o1.casPosition!! < o2.casPosition!!) {
                    return@Comparator -1
                } else if (o1.casPosition!! < o2.casPosition!!) {
                    return@Comparator 1
                }
                0
            })
        }

        fun filterNotNull(data : Array<BidChartDataBean>?) : Array<BidChartDataBean>? {
            return data?.filterNotNull()?.toTypedArray()
        }

        fun filterAdd(addData : List<BidChartDataBean>, lastPosition : Float) : List<BidChartDataBean> {
            return addData.filter { item ->
                    item.casPosition?.let { it - lastPosition > 0 } ?: false
            }
        }

    }



    @SerializedName("action")
    var action : String? = null
    @SerializedName("rise_fall")
    var riseFall : IntArray? = null
    @SerializedName("zhangfu_range")
    var zfRange : IntArray? = null
    @SerializedName("bidding_direction")
    var bidDirection : Float? = null //竞价走势
    @SerializedName("rise_percent")
    var risePercent : Float? = null
    @SerializedName("cas_position")
    var casPosition : Float? = null


}