package com.hexin.android.component.yidong.dpbidyd.model

import com.google.gson.annotations.SerializedName
import com.hexin.util.StringUtils

/**
 * 竞价涨停潜力
 * Created by yuegang on 19-3-6.
 */
class BidPotentialBean : BidYesterdayDataBean() {

    @SerializedName("jlzzl")
    var jlzzl: Float? = null // 竞量/昨量
    @SerializedName("zrztfcb")
    var zrztfcb: Float? = null // 昨日涨停封成比
    @SerializedName("closeRise")
    var closeRise: Float? = null // 收盘价(历史竞价页面使用)
    var newRise: String? = null // 最新涨幅(当日竞价结束后从主站单独请求获取)

    override fun available(): Boolean {
        return super.available() && jlzzl != null && StringUtils.isNumerical(jlzzl.toString())
                && zrztfcb != null && StringUtils.isNumerical(zrztfcb.toString())
    }
}