package com.hexin.android.component.yidong.dpbidyd.model

import com.google.gson.annotations.SerializedName
import com.hexin.util.config.EQConstants

/**
 * 包括竞价看多、涨停潜力、昨日涨停表现
 * Created by yuegang on 19-3-6.
 */
class BidSelectionDataBean {

    companion object {
        const val AUCTION_STAGE_900_915 = 0
        const val AUCTION_STAGE_915_926 = 1
        const val AUCTION_STAGE_926_900 = 2
    }

    @SerializedName("callAuctionStage")
    var callAuctionStage : Int? = EQConstants.INVALID //9:00-9:15 --> 0 ;  9:15-9:26 --> 1 ; 9:26-day+1 9:00 --> 2
    @SerializedName("isCallAuction")
    var isCallAuction : Boolean? = false //9:00 - 9:25 --> true    9:26 - day+1 9:00 --> false
    @SerializedName("callAuctionPlate")
    var callAuctionPlate : List<BidYDBanKuaiBean>? = null
    @SerializedName("callAuctionHotStock")
    var callAuctionHotStock : List<BidPotentialBean>? = null
    @SerializedName("callAuctionLimitUpStock")
    var callAuctionLimitUpStock : List<BidYesterdayDataBean>? = null

    fun stuffAndFilter() {
        val tempPlate = callAuctionPlate?.filterNotNull()?.filter { it.available() }
        tempPlate?.forEach {
            it.isCallAuction = isCallAuction ?: false
            it.callAuctionStage = callAuctionStage ?: EQConstants.INVALID
        }
        callAuctionPlate = tempPlate

        val tempHot = callAuctionHotStock?.filterNotNull()?.filter { it.available() }
        tempHot?.forEach {
            it.isCallAuction = isCallAuction ?: false
            it.callAuctionStage = callAuctionStage ?: EQConstants.INVALID
        }
        callAuctionHotStock = tempHot

        val tempLimitUp = callAuctionLimitUpStock?.filterNotNull()?.filter { it.available() }
        tempLimitUp?.forEach {
            it.isCallAuction = isCallAuction ?: false
            it.callAuctionStage = callAuctionStage ?: EQConstants.INVALID
        }
        callAuctionLimitUpStock = tempLimitUp
    }
}