package com.hexin.android.component.yidong.dpbidyd.request

import android.text.TextUtils
import com.hexin.android.component.yidong.dpbidyd.model.BidChartDataBean
import com.hexin.util.gson.GsonUtil

/**
 * 大盘集合竞价主页走势图数据请求和管理
 * Created by yuegang on 19-3-6.
 */
class ChartDataClient(stock : String) : AbsDataClient<Array<BidChartDataBean>>() {

    private val MAX_DATA_NUM = 61
    private val TAG = "ChartDataClient"

    companion object {
        const val STOCK_1A0001 = "1A0001"
        const val STOCK_399001 = "399001"
        const val STOCK_399006 = "399006"
        val STOCK_ARRAY = arrayOf(STOCK_1A0001, STOCK_399001, STOCK_399006)
    }

    private val REQ_KEY_CHART_REAL = "dpjjyd_cas_%s"

    var mStock : String? = STOCK_1A0001

    init {
        mStock = stock
    }

    override fun parse(json: String): Array<BidChartDataBean>? {
        return if (TextUtils.isEmpty(json)) {
            null
        } else {
            GsonUtil.fromJson(json, Array<BidChartDataBean>::class.java)
        }
    }

    override fun reqNum(): Int {
        return MAX_DATA_NUM
    }

    override fun tag(): String {
        return TAG
    }

    override fun reqKey(): String {
        return REQ_KEY_CHART_REAL.format(mStock)
    }

}